/*
 7 4    
     Attiny13A
*/

.include "C:\Program Files\Atmel\AVR Studio 5.0\avrassembler\include\tn13Adef.inc"

/**************************************************************************************/
/*			                               		                              */
/**************************************************************************************/
//    
.macro	PUSHTMP
	push		tmp1
	in			tmp1,		SREG
	push		tmp1
	push		tmp2
	push		tmp3
	push		tmp4
.endmacro

//    
.macro	POPTMP
	pop			tmp4
	pop			tmp3
	pop			tmp2	
	pop			tmp1
	out			SREG,		tmp1
	pop			tmp1
.endmacro

//   
.macro	PUSHARG
	push		arg1
	push		arg2
.endmacro

//   
.macro	POPARG
	pop			arg2
	pop			arg1
.endmacro

/**************************************************************************************/
/*                                                                     */
/**************************************************************************************/

;.equ	c_max_gradations	=	128;	    
.equ	DIGIT_STROB			= DDB0	;   
.equ	SEGMENT_STROB		= DDB1	;   
.equ	DIGIT_SEGMENT_DATA	= DDB2	;    

/**************************************************************************************/
/*                                                                   */
/**************************************************************************************/
.dseg
.org	0x60

ledstr:		.byte   4			;,     
								;    
								; 3 - 

statusled:	.byte	1			;  LED 

.def	tmp1	= r16
.def	tmp2	= r17
.def	tmp3	= r18
.def	tmp4	= r19

.def	arg1	=	r20
.def	arg2	=	r21



/**************************************************************************************/
/*                                                                   */
/**************************************************************************************/
.cseg
.org 0
	rjmp	event_reset
	reti;	rjmp	event_button_down	; External Interrupt 0
	reti					; External Interrupt Request 0
	rjmp	event_timer		; Timer/Counter0 Overflow
	reti					; EEPROM Ready
	reti					; Analog Comparator
	reti					; Timer/Counter Compare Match A
	reti					; Timer/Counter Compare Match B
	reti					; Watchdog Time-out
	reti					; ADC Conversion Complete

/**************************************************************************************/
/*                                                              */
/**************************************************************************************/
event_reset:
	/**/
	ldi	tmp1,	RAMEND
	out	SPL,	tmp1

	ldi			arg1,		0
	ldi			arg2,		0b01100000
	rcall		put_char
	ldi			arg1,		1
	ldi			arg2,		0b11011010
	rcall		put_char	
	ldi			arg1,		2
	ldi			arg2,		0b11110010
	rcall		put_char	
	ldi			arg1,		3
	ldi			arg2,		0b01100110
	rcall		put_char
	/*  /; 2,3,4  - RGB */
	ldi		tmp1,	1<<DIGIT_STROB|1<<SEGMENT_STROB|1<<DIGIT_SEGMENT_DATA|0<<DDB3|0<<DDB4
	out		DDRB,	tmp1
	clr		tmp1
	out		PORTB,	tmp1

	/* */
	ldi		tmp1,	1<<CS00 | 1<<CS01 |	0<<CS02;    
	out		TCCR0B,	tmp1
	ldi		tmp1,	1<<TOIE0; 
	out		TIMSK0,	tmp1

	/* statusled*/
	ldi			YL,			low(statusled)
	ldi			YH,			high(statusled)
	ldi			tmp1,		3
	st			Y,			tmp1


	sei
main:
	rjmp	main
/**************************************************************************************/
/*                                                                 */
/**************************************************************************************/
event_timer:
	PUSHTMP

	//    RAM,    1    tmp1 (0..3)
	ldi			YL,			low(statusled)
	ldi			YH,			high(statusled)
	ld			tmp1,		Y
	inc			tmp1
	cpi			tmp1,		4
	brlo		ev_t_skip_res
	clr			tmp1
	ldi			tmp2,		1
ev_t_skip_res:
	st			Y,			tmp1			;    RAM


	//       
	clr			tmp3
	sbrc		tmp2,		0						;  0 -   1   
	ldi			tmp3,		1<<DIGIT_SEGMENT_DATA	; 
	out			PORTB,		tmp3
	ori			tmp3,		1<<DIGIT_STROB
	nop
	nop
	out			PORTB,		tmp3
	clr			tmp3
	nop
	nop
	out			PORTB,		tmp3



	//    RAM   
	ldi			YL,			low(ledstr+3)
	ldi			YH,			high(ledstr+3)
	
	sub			YL,			tmp1			;   ,    
	sbci		YH,			0

	ld			tmp1,		Y

	//        (  tmp1)
	ldi			tmp4,		8
ev_t_segment_loop:
	clr			tmp3
	ror			tmp1
	brcc		ev_t_segment_loop_no_c
	ldi			tmp3,		1<<DIGIT_SEGMENT_DATA; 1  
ev_t_segment_loop_no_c:
	
	out			PORTB,		tmp3
	ori			tmp3,		1<<SEGMENT_STROB
	nop
	out			PORTB,		tmp3
	clr			tmp3
	nop
	out			PORTB,		tmp3

	dec			tmp4
	brne		ev_t_segment_loop

//   ,   
	clr			tmp1
	ori			tmp1,		1<<DIGIT_STROB
	out			PORTB,		tmp1
	nop
	nop
	clr			tmp1
	out			PORTB,		tmp1

	POPTMP
	reti

/**************************************************************************************/
/*                                                               */
/**************************************************************************************/
/*    .    	  */
/*put_char(pos,char)                                                                  */
/*pos - (0- , 3 - )                                        */
/*char -      . A- , G - 7     */
/**************************************************************************************/
put_char:
	cli
	push		tmp1
	ldi			tmp1,		0b11111111

	ldi			YL,			low(ledstr+3)
	ldi			YH,			high(ledstr+3)
	
	sub			YL,			arg1			;   ,    
	sbci		YH,			0

	sub			tmp1,		arg2			;    -  ,  
											;   1    0.  
											;0b11111111       
	st			Y,			tmp1			;    

	pop			tmp1
	sei
	ret







